REM     The Standart GNU Personal Binary To Hexadecimal Text Convertor.
REM     Copyright (C) Sandul Yura Valentinovich.
REM     (R) Wednesday, 5 March 2003 year.
REM     This program is free software; you can redistribute it and/or modify
REM it under the terms of the GNU General Public License as published by the
REM Free Software Foundation; either version 2 of the License, or (at your
REM option) any later version.
REM     This program is distributed in the hope that it will be useful, but
REM WITHOUT ANY WARRANTY; without even the implied warranty of
REM MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
REM Public License for more details.
REM     You should have received a copy of the GNU General Public License
REM along with this program; if not, write to the Free Software Foundation,
REM Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
REM
REM $DYNAMIC
DECLARE SUB ScratchScreen ()
DECLARE SUB OutBox (Title$, Message$)
DECLARE SUB MakeBox (BoxColumn%, BoxRow%, BoxWidth%, BoxHeight%)
DECLARE SUB SecondsToDateAndTime (SecondsCount#, HourValue%, MinuteValue%, SecondValue%, DayValue%, MonthValue%, YearValue%, DayOfWeekValue%)
DECLARE FUNCTION DateAndTimeToSeconds# (HourValue%, MinuteValue%, SecondValue%, DayValue%, MonthValue%, YearValue%)
DECLARE FUNCTION DayName$ (DayNumber%)
DECLARE FUNCTION DayOfWeek% (DayValue%, MonthValue%, YearValue%)
DECLARE FUNCTION DayOfWeekName$ (DayValue%, MonthValue%, YearValue%)
DECLARE FUNCTION DaysCount& (DayValue%, MonthValue%, YearValue%)
DECLARE FUNCTION InputBox% (Title$, Message$, InputTextLine$)
DECLARE FUNCTION IsLeapYear% (YearValue%)
DECLARE FUNCTION MenuBox% (ItemsCount%)
DECLARE FUNCTION MessageBox% (Title$, Message$)
DECLARE FUNCTION MonthDays% (MonthValue%, YearValue%)
DECLARE FUNCTION MonthDaysCount% (MonthValue%, YearValue%)
DECLARE FUNCTION MonthName$ (MonthNumber%)
OPTION BASE 1
CONST False% = 0
CONST True% = NOT False%
DIM SHARED MenuItems$(5)
DIM StartDate$
DIM StartTime$
DIM CurrentDate$
DIM CurrentTime$
DIM WorkLine$
DIM OldFilePosition&
DIM OldSecond%
DIM UserBreak%
DIM Crc32Table&(256)
DIM Index%
DIM CrcIndex%
DIM Crc&
DIM WorkValue%
DIM WorkHourValue%
DIM WorkMinuteValue%
DIM WorkSecondValue%
DIM WorkDayValue%
DIM WorkMonthValue%
DIM WorkYearValue%
DIM WorkDayOfWeekValue%
DIM SourceFileName$
DIM TargetFileName$
DIM LinesCount&
DIM OriginalFileName$
DIM OriginalFileSize&
DIM OriginalCrc32Code&
DIM OriginalDateTime$
DIM ExitCode%
SCREEN 0, 1, 0, 0
SourceFileName$ = "File.dat"
TargetFileName$ = "File.hex"
FOR Index% = 1 TO 256
 Crc& = Index% - 1
 FOR CrcIndex% = 1 TO 8
  IF ((INT(Crc& / 2) * 2) <> Crc&) THEN Crc& = INT(Crc& / 2) XOR &HEDB88320 ELSE Crc& = INT(Crc& / 2)
 NEXT CrcIndex%
 Crc32Table&(Index%) = Crc&
NEXT Index%
DO
 CALL ScratchScreen
 MenuItems$(1) = "Change source file name (" + SourceFileName$ + ".)."
 MenuItems$(2) = "Change target file name (" + TargetFileName$ + ".)."
 MenuItems$(3) = "Convert source data file to target hexadecimal text file."
 MenuItems$(4) = "Convert source hexadecimal text file to target data file."
 MenuItems$(5) = "Quit."
 SELECT CASE MenuBox%(5)
 CASE 0
   EXIT DO
 CASE 1
   CALL ScratchScreen
   WorkLine$ = ""
   IF InputBox%("HexBinary.", "Please enter source file name.", WorkLine$) THEN
    CALL ScratchScreen
    WorkLine$ = UCASE$(LEFT$(LTRIM$(RTRIM$(WorkLine$)), 1)) + LCASE$(MID$(LTRIM$(RTRIM$(WorkLine$)), 2))
    IF (WorkLine$ = "") OR (LEN(WorkLine$) > 12) OR (INSTR(WorkLine$, ":") > 0) OR (INSTR(WorkLine$, "/") > 0) OR (INSTR(WorkLine$, "\") > 0) OR (INSTR(WorkLine$, "?") > 0) OR (INSTR(WorkLine$, "*") > 0) THEN CALL OutBox("HexBinary.", "You input the invalid file name.") ELSE SourceFileName$ = WorkLine$
   END IF
 CASE 2
   CALL ScratchScreen
   WorkLine$ = ""
   IF InputBox%("HexBinary.", "Please enter target file name.", WorkLine$) THEN
    CALL ScratchScreen
    WorkLine$ = UCASE$(LEFT$(LTRIM$(RTRIM$(WorkLine$)), 1)) + LCASE$(MID$(LTRIM$(RTRIM$(WorkLine$)), 2))
    IF (WorkLine$ = "") OR (LEN(WorkLine$) > 12) OR (INSTR(WorkLine$, ":") > 0) OR (INSTR(WorkLine$, "/") > 0) OR (INSTR(WorkLine$, "\") > 0) OR (INSTR(WorkLine$, "?") > 0) OR (INSTR(WorkLine$, "*") > 0) THEN CALL OutBox("HexBinary.", "You input the invalid file name.") ELSE TargetFileName$ = WorkLine$
   END IF
 CASE 3
   CALL ScratchScreen
   ON ERROR GOTO CannotOpenSourceFile
   OPEN SourceFileName$ FOR RANDOM AS #1 LEN = 1
   ON ERROR GOTO 0
   FIELD #1, 1 AS FileData$
   StartDate$ = DATE$
   StartTime$ = TIME$
   OldFilePosition& = 0
   UserBreak% = False%
   OldSecond% = NOT VAL(MID$(StartTime$, 7, 2))
   Crc& = &HFFFFFFFF
   GOSUB OutGetCrc32StatusBox
   DO WHILE NOT EOF(1)
    GOSUB OutGetCrc32Status
    IF INKEY$ = CHR$(27) THEN
     UserBreak% = True%
     EXIT DO
    END IF
    ON ERROR GOTO CannotReadFromSourceFileForGetCrc32
    GET #1
    ON ERROR GOTO 0
    IF NOT EOF(1) THEN
     WorkValue% = ABS((Crc& MOD &H100) XOR ASC(FileData$))
     IF WorkValue% > 255 THEN WorkValue% = 255
     Crc& = Crc32Table&(WorkValue% + 1) XOR INT(Crc& / &H100)
    END IF
   LOOP
   CLOSE #1
   CALL ScratchScreen
   IF UserBreak% = True% THEN
    CALL OutBox("HexBinary.", "User break.")
   ELSE
    ON ERROR GOTO CannotOpenSourceFile
    OPEN SourceFileName$ FOR RANDOM AS #1 LEN = 1
    ON ERROR GOTO CannotOpenTargetFile
    OPEN TargetFileName$ FOR OUTPUT AS #2
    ON ERROR GOTO 0
    FIELD #1, 1 AS FileData$
    StartDate$ = DATE$
    StartTime$ = TIME$
    OldFilePosition& = 0
    UserBreak% = False%
    OldSecond% = NOT VAL(MID$(StartTime$, 7, 2))
    GOSUB OutBinToHexStatusBox
    ON ERROR GOTO CannotWriteToTargetFileForConvertToHex
    PRINT #2, "" + STRING$(52, "") + ""
    PRINT #2, "              BINARY HEXADECIMAL FILE.              "
    PRINT #2, "" + STRING$(52, "") + ""
    PRINT #2, "     File name=" + SourceFileName$ + SPACE$(53 - LEN("     File name=" + SourceFileName$)) + ""
    PRINT #2, "     File size=" + LTRIM$(STR$(LOF(1))) + " bytes." + SPACE$(53 - LEN("     File size=" + LTRIM$(STR$(LOF(1))) + " bytes.")) + ""
    PRINT #2, "   CRC-32 Code=" + LTRIM$(STR$(Crc&)) + SPACE$(53 - LEN("   CRC-32 Code=" + LTRIM$(STR$(Crc&)))) + ""
    PRINT #2, "File date/time=" + LTRIM$(STR$(DateAndTimeToSeconds#(VAL(MID$(StartTime$, 1, 2)), VAL(MID$(StartTime$, 4, 2)), VAL(MID$(StartTime$, 7, 2)), VAL(MID$(StartDate$, 4, 2)), VAL(MID$(StartDate$, 1, 2)), VAL(MID$(StartDate$, 7, 4))))) + " seconds." + SPACE$(53 - LEN("File date/time=" + LTRIM$(STR$(DateAndTimeToSeconds#(VAL(MID$(StartTime$, 1, 2)), VAL(MID$(StartTime$, 4, 2)), VAL(MID$(StartTime$, 7, 2)), VAL(MID$(StartDate$, 4, 2)), VAL(MID$(StartDate$, 1, 2)), VAL(MID$(StartDate$, 7, 4))))) + " seconds.")) + ""
    PRINT #2, "" + STRING$(52, "") + ""
    PRINT #2, "" + STRING$(49, "") + "Ŀ"
    ON ERROR GOTO 0
    LinesCount& = 6
    WorkLine$ = ""
    DO WHILE NOT EOF(1)
     GOSUB OutBinToHexStatus
     IF INKEY$ = CHR$(27) THEN
      UserBreak% = True%
      EXIT DO
     END IF
     ON ERROR GOTO CannotReadSourceFileForConvertToHex
     GET #1
     ON ERROR GOTO 0
     IF NOT EOF(1) THEN
      IF LEN(HEX$(ASC(FileData$))) < 2 THEN WorkLine$ = WorkLine$ + "0" + HEX$(ASC(FileData$)) ELSE WorkLine$ = WorkLine$ + HEX$(ASC(FileData$))
      IF LEN(WorkLine$) = 50 THEN
       ON ERROR GOTO CannotWriteToTargetFileForConvertToHex
       PRINT #2, "" + WorkLine$ + ""
       ON ERROR GOTO 0
       LinesCount& = LinesCount& + 1
       WorkLine$ = ""
      END IF
     END IF
    LOOP
    IF UserBreak% THEN
     CLOSE #1
     CLOSE #2
     KILL TargetFileName$
     CALL ScratchScreen
     CALL OutBox("HexBinary.", "User break.")
    ELSE
     IF WorkLine$ <> "" THEN
      ON ERROR GOTO CannotWriteToTargetFileForConvertToHex
      PRINT #2, "" + WorkLine$ + SPACE$(50 - LEN(WorkLine$)) + ""
      ON ERROR GOTO 0
     END IF
     ON ERROR GOTO CannotWriteToTargetFileForConvertToHex
     PRINT #2, "" + STRING$(49, "") + "ٺ"
     PRINT #2, "" + STRING$(51, "") + ""
     PRINT #2, CHR$(26);
     ON ERROR GOTO 0
     CLOSE #1
     CLOSE #2
     CALL ScratchScreen
     CALL OutBox("HexBinary.", "Source data file is succefully converted to target hexadecimal text file.")
    END IF
   END IF
 CASE 4
   CALL ScratchScreen
   ON ERROR GOTO CannotOpenSourceFile
   OPEN SourceFileName$ FOR INPUT AS #1
   ON ERROR GOTO 0
   StartDate$ = DATE$
   StartTime$ = TIME$
   UserBreak% = False%
   ExitCode% = 0
   LinesCount& = 7
   OldSecond% = NOT VAL(MID$(StartTime$, 7, 2))
   ON ERROR GOTO CannotReadFromHexSourceFile
   LINE INPUT #1, WorkLine$
   ON ERROR GOTO 0
   IF WorkLine$ <> "" + STRING$(52, "") + "" THEN
    CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
    CLOSE #1
   ELSE
    ON ERROR GOTO CannotReadFromHexSourceFile
    LINE INPUT #1, WorkLine$
    ON ERROR GOTO 0
    IF WorkLine$ <> "              BINARY HEXADECIMAL FILE.              " THEN
     CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
     CLOSE #1
    ELSE
     ON ERROR GOTO CannotReadFromHexSourceFile
     LINE INPUT #1, WorkLine$
     ON ERROR GOTO 0
     IF WorkLine$ <> "" + STRING$(52, "") + "" THEN
      CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
      CLOSE #1
     ELSE
      ON ERROR GOTO CannotReadFromHexSourceFile
      LINE INPUT #1, WorkLine$
      ON ERROR GOTO 0
      IF (LEFT$(WorkLine$, 16) <> "     File name=") OR (RIGHT$(WorkLine$, 1) <> "") OR (LEN(WorkLine$) <> 54) THEN
       CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
       CLOSE #1
      ELSE
       WorkLine$ = MID$(WorkLine$, 17)
       OriginalFileName$ = RTRIM$(MID$(WorkLine$, 1, LEN(WorkLine$) - 1))
       ON ERROR GOTO CannotReadFromHexSourceFile
       LINE INPUT #1, WorkLine$
       ON ERROR GOTO 0
       IF (LEFT$(WorkLine$, 16) <> "     File size=") OR (INSTR(WorkLine$, " bytes.") = 0) OR (RIGHT$(WorkLine$, 1) <> "") OR (LEN(WorkLine$) <> 54) THEN
        CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
        CLOSE #1
       ELSE
        WorkLine$ = MID$(WorkLine$, 17)
        OriginalFileSize& = VAL(MID$(WorkLine$, 1, INSTR(WorkLine$, " bytes.") - 1))
        ON ERROR GOTO CannotReadFromHexSourceFile
        LINE INPUT #1, WorkLine$
        ON ERROR GOTO 0
        IF (LEFT$(WorkLine$, 16) <> "   CRC-32 Code=") OR (RIGHT$(WorkLine$, 1) <> "") OR (LEN(WorkLine$) <> 54) THEN
         CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
         CLOSE #1
        ELSE
         WorkLine$ = MID$(WorkLine$, 17)
         OriginalCrc32Code& = VAL(RTRIM$(MID$(WorkLine$, 1, LEN(WorkLine$) - 1)))
         ON ERROR GOTO CannotReadFromHexSourceFile
         LINE INPUT #1, WorkLine$
         ON ERROR GOTO 0
         IF (LEFT$(WorkLine$, 16) <> "File date/time=") OR (INSTR(WorkLine$, " seconds.") = 0) OR (RIGHT$(WorkLine$, 1) <> "") OR (LEN(WorkLine$) <> 54) THEN
          CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
          CLOSE #1
         ELSE
          WorkLine$ = MID$(WorkLine$, 17)
          CALL SecondsToDateAndTime(VAL(RTRIM$(MID$(WorkLine$, 1, LEN(WorkLine$) - 1))), WorkHourValue%, WorkMinuteValue%, WorkSecondValue%, WorkDayValue%, WorkMonthValue%, WorkYearValue%, WorkDayOfWeekValue%)
          OriginalDateTime$ = "Date: " + DayName$(WorkDayOfWeekValue%) + ", " + LTRIM$(STR$(WorkDayValue%)) + " " + MonthName$(WorkMonthValue%) + " " + LTRIM$(STR$(WorkYearValue%)) + " year. Time: " + STRING$(2 - LEN(LTRIM$(STR$(WorkHourValue%))), "0") + LTRIM$(STR$(WorkHourValue%)) + ":" + STRING$(2 - LEN(LTRIM$(STR$(WorkMinuteValue%))), "0") + LTRIM$(STR$(WorkMinuteValue%)) + ":" + STRING$(2 - LEN(LTRIM$(STR$(WorkSecondValue%))), "0") + LTRIM$(STR$(WorkSecondValue%))
          ON ERROR GOTO CannotReadFromHexSourceFile
          LINE INPUT #1, WorkLine$
          ON ERROR GOTO 0
          IF WorkLine$ <> "" + STRING$(52, "") + "" THEN
           CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
           CLOSE #1
           CLOSE #2
           KILL TargetFileName$
          ELSE
           ON ERROR GOTO CannotReadFromHexSourceFile
           LINE INPUT #1, WorkLine$
           ON ERROR GOTO 0
           IF WorkLine$ <> "" + STRING$(49, "") + "Ŀ" THEN
            CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
            CLOSE #1
            CLOSE #2
            KILL TargetFileName$
           ELSE
            IF MessageBox%("HexBinary.", "Convert source hexadecimal file to original file name (" + OriginalFileName$ + ") or to your entered file name (" + TargetFileName$ + ")?") THEN TargetFileName$ = OriginalFileName$
            CALL ScratchScreen
            ON ERROR GOTO CannotOpenTargetFile
            OPEN TargetFileName$ FOR OUTPUT AS #2
            ON ERROR GOTO 0
            Crc& = &HFFFFFFFF
            GOSUB OutHexToBinStatusBox
            DO WHILE NOT EOF(1)
             GOSUB OutHexToBinStatus
             IF INKEY$ = CHR$(27) THEN
              ExitCode% = 1
              EXIT DO
             END IF
             ON ERROR GOTO CannotReadFromSourceFileForConvertToBin
             LINE INPUT #1, WorkLine$
             ON ERROR GOTO 0
             IF WorkLine$ = "" + STRING$(49, "") + "ٺ" THEN EXIT DO
             IF (LEFT$(WorkLine$, 2) <> "") OR (RIGHT$(WorkLine$, 2) <> "") OR ((INT(LEN(WorkLine$) / 2) * 2) <> LEN(WorkLine$)) THEN
              ExitCode% = 2
              EXIT DO
             END IF
             WorkLine$ = RTRIM$(MID$(WorkLine$, 3, LEN(WorkLine$) - 4))
             LinesCount& = LinesCount& + 1
             WHILE WorkLine$ <> ""
              WorkValue% = ABS((Crc& MOD &H100) XOR VAL("&H" + LEFT$(WorkLine$, 2)))
              IF WorkValue% > 255 THEN WorkValue% = 255
              Crc& = Crc32Table&(WorkValue% + 1) XOR INT(Crc& / &H100)
              GOSUB OutHexToBinStatus
              ON ERROR GOTO CannotWriteToTargetFileForConvertToBin
              PRINT #2, CHR$(VAL("&H" + LEFT$(WorkLine$, 2)));
              ON ERROR GOTO 0
              WorkLine$ = MID$(WorkLine$, 3)
             WEND
            LOOP
            CLOSE #1
            CLOSE #2
            CALL ScratchScreen
            SELECT CASE ExitCode%
            CASE 0
              IF OriginalCrc32Code& <> Crc& THEN CALL OutBox("HexBinary.", "WARNING! Source hexadecimal text file is succefully converted to target data file, and original CRC-32 code of hexadecimal file is not equalient to new CRC-32 code of generated file.") ELSE CALL OutBox("HexBinary.", "Source hexadecimal text file is succefully converted to target data file.")
            CASE 1
              CALL OutBox("HexBinary.", "User break.")
              KILL TargetFileName$
            CASE 2
              CALL OutBox("HexBinary.", "Invalid source hexadecimal text file.")
              KILL TargetFileName$
            END SELECT
           END IF
          END IF
         END IF
        END IF
       END IF
      END IF
     END IF
    END IF
   END IF
 CASE 5
   EXIT DO
 END SELECT
WorkRepeat:
LOOP
COLOR 7, 0
CLS
LOCATE 1, 1, 1, 7, 8
END
OutGetCrc32StatusBox:
 CALL MakeBox(1, 6, 77, 11)
 PRINT "Calculate CRC-32 code for convert data file to hexadecimal text." + SPACE$(13);
 COLOR 1, 7
 LOCATE 8, 2, 0
 PRINT "        File name: ";
 COLOR 4, 7
 PRINT SourceFileName$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 9, 2, 0
 PRINT "        File size: ";
 COLOR 4, 7
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOF(1))))) + LTRIM$(STR$(LOF(1)));
 COLOR 1, 7
 PRINT " bytes.";
 LOCATE 10, 2, 0
 PRINT "    File position: " + SPACE$(10) + ".";
 LOCATE 11, 2, 0
 PRINT "Calculating speed: " + SPACE$(10) + " bytes per second.";
 LOCATE 12, 2, 0
 PRINT "       CRC-32 Code=" + SPACE$(8) + ".";
 LOCATE 13, 2, 0
 PRINT "   % Completed.";
 LOCATE 14, 2, 0
 PRINT "  Start time: ";
 COLOR 4, 7
 PRINT "Date: " + DayOfWeekName$(VAL(MID$(StartDate$, 4, 2)), VAL(MID$(StartDate$, 1, 2)), VAL(MID$(StartDate$, 7, 4))) + ", " + LTRIM$(STR$(VAL(MID$(StartDate$, 4, 2)))) + " " + MonthName$(VAL(MID$(StartDate$, 1, 2))) + " " + LTRIM$(STR$(VAL(MID$(StartDate$, 7, 4)))) + " year. Time: " + StartTime$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 15, 2, 0
 PRINT "Current time:";
 LOCATE 16, 2, 0
 PRINT "   Past time:";
 COLOR 14, 7
 LOCATE 17, 2, 0
 PRINT "[ESC]=Break.";
 RETURN
OutGetCrc32Status:
 COLOR 4, 7
 LOCATE 10, 21, 0
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOC(1))))) + LTRIM$(STR$(LOC(1)));
 LOCATE 12, 21, 0
 PRINT SPACE$(8 - LEN(HEX$(Crc&))) + HEX$(Crc&);
 LOCATE 13, 2, 0
 PRINT STRING$(3 - LEN(LTRIM$(STR$(INT((LOC(1) * 100) / LOF(1))))), "0") + LTRIM$(STR$(INT((LOC(1) * 100) / LOF(1))));
 CurrentDate$ = DATE$
 CurrentTime$ = TIME$
 IF VAL(MID$(CurrentTime$, 7, 2)) <> OldSecond% THEN
  OldSecond% = VAL(MID$(CurrentTime$, 7, 2))
  LOCATE 11, 21, 0
  PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOC(1) - OldFilePosition&)))) + LTRIM$(STR$(LOC(1) - OldFilePosition&));
  OldFilePosition& = LOC(1)
  LOCATE 15, 16, 0
  PRINT SPACE$(63);
  LOCATE 15, 16, 0
  PRINT "Date: " + DayOfWeekName$(VAL(MID$(CurrentDate$, 4, 2)), VAL(MID$(CurrentDate$, 1, 2)), VAL(MID$(CurrentDate$, 7, 4))) + ", " + LTRIM$(STR$(VAL(MID$(CurrentDate$, 4, 2)))) + " " + MonthName$(VAL(MID$(CurrentDate$, 1, 2))) + " " + LTRIM$(STR$(VAL(MID$(CurrentDate$, 7, 4)))) + " year. Time: " + CurrentTime$;
  COLOR 1, 7
  PRINT ".";
  CALL SecondsToDateAndTime(DateAndTimeToSeconds#(VAL(MID$(CurrentTime$, 1, 2)), VAL(MID$(CurrentTime$, 4, 2)), VAL(MID$(CurrentTime$, 7, 2)), VAL(MID$(CurrentDate$, 4, 2)), VAL(MID$(CurrentDate$, 1, 2)), VAL(MID$(CurrentDate$, 7, 4))) - DateAndTimeToSeconds#(VAL(MID$(StartTime$, 1, 2)), VAL(MID$(StartTime$, 4, 2)), VAL(MID$(StartTime$, 7, 2)), VAL(MID$(StartDate$, 4, 2)), VAL(MID$(StartDate$, 1, 2)), VAL(MID$(StartDate$, 7, 4))), WorkHourValue%, WorkMinuteValue%, WorkSecondValue%, WorkDayValue%, WorkMonthValue%, WorkYearValue%, WorkDayOfWeekValue%)
  COLOR 4, 7
  LOCATE 16, 16, 0
  PRINT SPACE$(63);
  LOCATE 16, 16, 0
  PRINT "Date: " + DayName$(WorkDayOfWeekValue%) + ", " + LTRIM$(STR$(WorkDayValue%)) + " " + MonthName$(WorkMonthValue%) + " " + LTRIM$(STR$(WorkYearValue%)) + " year. Time: " + STRING$(2 - LEN(LTRIM$(STR$(WorkHourValue%))), "0") + LTRIM$(STR$(WorkHourValue%)) + ":" + STRING$(2 - LEN(LTRIM$(STR$(WorkMinuteValue%))), "0") + LTRIM$(STR$(WorkMinuteValue%)) + ":" + STRING$(2 - LEN(LTRIM$(STR$(WorkSecondValue%))), "0") + LTRIM$(STR$(WorkSecondValue%));
  COLOR 1, 7
  PRINT ".";
 END IF
 RETURN
OutBinToHexStatusBox:
 CALL MakeBox(1, 5, 77, 13)
 PRINT "Conversion data to hexadecimal text." + SPACE$(41);
 CALL MakeBox(1, 5, 77, 13)
 PRINT "Conversion data to hexadecimal text." + SPACE$(41);
 COLOR 1, 7
 LOCATE 7, 2, 0
 PRINT "    Source file name: ";
 COLOR 4, 7
 PRINT SourceFileName$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 8, 2, 0
 PRINT "    Target file name: ";
 COLOR 4, 7
 PRINT TargetFileName$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 9, 2, 0
 PRINT "    Source file size: ";
 COLOR 4, 7
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOF(1))))) + LTRIM$(STR$(LOF(1)));
 COLOR 1, 7
 PRINT " bytes.";
 LOCATE 10, 2, 0
 PRINT "    Target file size: " + SPACE$(10) + " bytes.";
 LOCATE 11, 2, 0
 PRINT "  Making line number: " + SPACE$(10) + ".";
 LOCATE 12, 2, 0
 PRINT "Source file position: " + SPACE$(10) + ".";
 LOCATE 13, 2, 0
 PRINT "    Conversion speed: " + SPACE$(10) + " bytes per second.";
 LOCATE 14, 2, 0
 PRINT "   % Completed.";
 LOCATE 15, 2, 0
 PRINT "  Start time: ";
 COLOR 4, 7
 PRINT "Date: " + DayOfWeekName$(VAL(MID$(StartDate$, 4, 2)), VAL(MID$(StartDate$, 1, 2)), VAL(MID$(StartDate$, 7, 4))) + ", " + LTRIM$(STR$(VAL(MID$(StartDate$, 4, 2)))) + " " + MonthName$(VAL(MID$(StartDate$, 1, 2))) + " " + LTRIM$(STR$(VAL(MID$(StartDate$, 7, 4)))) + " year. Time: " + StartTime$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 16, 2, 0
 PRINT "Current time:";
 LOCATE 17, 2, 0
 PRINT "   Past time:";
 COLOR 14, 7
 LOCATE 18, 2, 0
 PRINT "[ESC]=Break.";
 RETURN
OutBinToHexStatus:
 COLOR 4, 7
 LOCATE 10, 24, 0
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOF(2))))) + LTRIM$(STR$(LOF(2)));
 LOCATE 11, 24, 0
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LinesCount&)))) + LTRIM$(STR$(LinesCount&));
 LOCATE 12, 24, 0
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOC(1))))) + LTRIM$(STR$(LOC(1)));
 LOCATE 14, 2, 0
 PRINT STRING$(3 - LEN(LTRIM$(STR$(INT((LOC(1) * 100) / LOF(1))))), "0") + LTRIM$(STR$(INT((LOC(1) * 100) / LOF(1))));
 CurrentDate$ = DATE$
 CurrentTime$ = TIME$
 IF VAL(MID$(CurrentTime$, 7, 2)) <> OldSecond% THEN
  OldSecond% = VAL(MID$(CurrentTime$, 7, 2))
  LOCATE 13, 24, 0
  PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOC(1) - OldFilePosition&)))) + LTRIM$(STR$(LOC(1) - OldFilePosition&));
  OldFilePosition& = LOC(1)
  LOCATE 16, 16, 0
  PRINT SPACE$(63);
  LOCATE 16, 16, 0
  PRINT "Date: " + DayOfWeekName$(VAL(MID$(CurrentDate$, 4, 2)), VAL(MID$(CurrentDate$, 1, 2)), VAL(MID$(CurrentDate$, 7, 4))) + ", " + LTRIM$(STR$(VAL(MID$(CurrentDate$, 4, 2)))) + " " + MonthName$(VAL(MID$(CurrentDate$, 1, 2))) + " " + LTRIM$(STR$(VAL(MID$(CurrentDate$, 7, 4)))) + " year. Time: " + CurrentTime$;
  COLOR 1, 7
  PRINT ".";
  CALL SecondsToDateAndTime(DateAndTimeToSeconds#(VAL(MID$(CurrentTime$, 1, 2)), VAL(MID$(CurrentTime$, 4, 2)), VAL(MID$(CurrentTime$, 7, 2)), VAL(MID$(CurrentDate$, 4, 2)), VAL(MID$(CurrentDate$, 1, 2)), VAL(MID$(CurrentDate$, 7, 4))) - DateAndTimeToSeconds#(VAL(MID$(StartTime$, 1, 2)), VAL(MID$(StartTime$, 4, 2)), VAL(MID$(StartTime$, 7, 2)), VAL(MID$(StartDate$, 4, 2)), VAL(MID$(StartDate$, 1, 2)), VAL(MID$(StartDate$, 7, 4))), WorkHourValue%, WorkMinuteValue%, WorkSecondValue%, WorkDayValue%, WorkMonthValue%, WorkYearValue%, WorkDayOfWeekValue%)
  COLOR 4, 7
  LOCATE 17, 16, 0
  PRINT SPACE$(63);
  LOCATE 17, 16, 0
  PRINT "Date: " + DayName$(WorkDayOfWeekValue%) + ", " + LTRIM$(STR$(WorkDayValue%)) + " " + MonthName$(WorkMonthValue%) + " " + LTRIM$(STR$(WorkYearValue%)) + " year. Time: " + STRING$(2 - LEN(LTRIM$(STR$(WorkHourValue%))), "0") + LTRIM$(STR$(WorkHourValue%)) + ":" + STRING$(2 - LEN(LTRIM$(STR$(WorkMinuteValue%))), "0") + LTRIM$(STR$(WorkMinuteValue%)) + ":" + STRING$(2 - LEN(LTRIM$(STR$(WorkSecondValue%))), "0") + LTRIM$(STR$(WorkSecondValue%));
  COLOR 1, 7
  PRINT ".";
 END IF
 RETURN
OutHexToBinStatusBox:
 CALL MakeBox(1, 2, 77, 19)
 PRINT "Conversion hexadecimal text to data." + SPACE$(41);
 COLOR 1, 7
 LOCATE 4, 2, 0
 PRINT "       Original file name: ";
 COLOR 4, 7
 PRINT OriginalFileName$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 5, 2, 0
 PRINT "       Original file size: ";
 COLOR 4, 7
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(OriginalFileSize&)))) + LTRIM$(STR$(OriginalFileSize&));
 COLOR 1, 7
 PRINT " bytes.";
 LOCATE 6, 2, 0
 PRINT "Original file CRC-32 code: ";
 COLOR 4, 7
 PRINT SPACE$(8 - LEN(HEX$(OriginalCrc32Code&))) + HEX$(OriginalCrc32Code&);
 COLOR 1, 7
 PRINT ".";
 LOCATE 7, 2, 0
 PRINT "  Original file date/time: ";
 COLOR 4, 7
 LOCATE 8, 2, 0
 PRINT OriginalDateTime$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 9, 2, 0
 PRINT "    Source file name: ";
 COLOR 4, 7
 PRINT SourceFileName$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 10, 2, 0
 PRINT "    Target file name: ";
 COLOR 4, 7
 PRINT TargetFileName$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 11, 2, 0
 PRINT "    Source file size: ";
 COLOR 4, 7
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOF(1))))) + LTRIM$(STR$(LOF(1)));
 COLOR 1, 7
 PRINT " bytes.";
 LOCATE 12, 2, 0
 PRINT "    Target file size: " + SPACE$(10) + " bytes.";
 LOCATE 13, 2, 0
 PRINT " Working line number: " + SPACE$(10) + ".";
 LOCATE 14, 2, 0
 PRINT "Source file position: " + SPACE$(10) + ".";
 LOCATE 15, 2, 0
 PRINT "  Current CRC-32 code=" + SPACE$(8) + ".";
 LOCATE 16, 2, 0
 PRINT "    Conversion speed: " + SPACE$(10) + " bytes per second.";
 LOCATE 17, 2, 0
 PRINT "   % Completed.";
 LOCATE 18, 2, 0
 PRINT "  Start time: ";
 COLOR 4, 7
 PRINT "Date: " + DayOfWeekName$(VAL(MID$(StartDate$, 4, 2)), VAL(MID$(StartDate$, 1, 2)), VAL(MID$(StartDate$, 7, 4))) + ", " + LTRIM$(STR$(VAL(MID$(StartDate$, 4, 2)))) + " " + MonthName$(VAL(MID$(StartDate$, 1, 2))) + " " + LTRIM$(STR$(VAL(MID$(StartDate$, 7, 4)))) + " year. Time: " + StartTime$;
 COLOR 1, 7
 PRINT ".";
 LOCATE 19, 2, 0
 PRINT "Current time:";
 LOCATE 20, 2, 0
 PRINT "   Past time:";
 COLOR 14, 7
 LOCATE 21, 2, 0
 PRINT "[ESC]=Break.";
 RETURN
OutHexToBinStatus:
 COLOR 4, 7
 LOCATE 12, 24, 0
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOF(2))))) + LTRIM$(STR$(LOF(2)));
 LOCATE 13, 24, 0
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LinesCount&)))) + LTRIM$(STR$(LinesCount&));
 LOCATE 14, 24, 0
 PRINT SPACE$(10 - LEN(LTRIM$(STR$(LOC(1) * 128)))) + LTRIM$(STR$(LOC(1) * 128));
 LOCATE 15, 24, 0
 PRINT SPACE$(8 - LEN(HEX$(Crc&))) + HEX$(Crc&);
 LOCATE 17, 2, 0
 PRINT STRING$(3 - LEN(LTRIM$(STR$(INT(((LOC(1) * 128) * 100) / LOF(1))))), "0") + LTRIM$(STR$(INT(((LOC(1) * 128) * 100) / LOF(1))));
 CurrentDate$ = DATE$
 CurrentTime$ = TIME$
 IF VAL(MID$(CurrentTime$, 7, 2)) <> OldSecond% THEN
  OldSecond% = VAL(MID$(CurrentTime$, 7, 2))
  LOCATE 16, 24, 0
  PRINT SPACE$(10 - LEN(LTRIM$(STR$((LOC(1) * 128) - OldFilePosition&)))) + LTRIM$(STR$((LOC(1) * 128) - OldFilePosition&));
  OldFilePosition& = LOC(1) * 128
  LOCATE 19, 16, 0
  PRINT SPACE$(63);
  LOCATE 19, 16, 0
  PRINT "Date: " + DayOfWeekName$(VAL(MID$(CurrentDate$, 4, 2)), VAL(MID$(CurrentDate$, 1, 2)), VAL(MID$(CurrentDate$, 7, 4))) + ", " + LTRIM$(STR$(VAL(MID$(CurrentDate$, 4, 2)))) + " " + MonthName$(VAL(MID$(CurrentDate$, 1, 2))) + " " + LTRIM$(STR$(VAL(MID$(CurrentDate$, 7, 4)))) + " year. Time: " + CurrentTime$;
  COLOR 1, 7
  PRINT ".";
  CALL SecondsToDateAndTime(DateAndTimeToSeconds#(VAL(MID$(CurrentTime$, 1, 2)), VAL(MID$(CurrentTime$, 4, 2)), VAL(MID$(CurrentTime$, 7, 2)), VAL(MID$(CurrentDate$, 4, 2)), VAL(MID$(CurrentDate$, 1, 2)), VAL(MID$(CurrentDate$, 7, 4))) - DateAndTimeToSeconds#(VAL(MID$(StartTime$, 1, 2)), VAL(MID$(StartTime$, 4, 2)), VAL(MID$(StartTime$, 7, 2)), VAL(MID$(StartDate$, 4, 2)), VAL(MID$(StartDate$, 1, 2)), VAL(MID$(StartDate$, 7, 4))), WorkHourValue%, WorkMinuteValue%, WorkSecondValue%, WorkDayValue%, WorkMonthValue%, WorkYearValue%, WorkDayOfWeekValue%)
  COLOR 4, 7
  LOCATE 20, 16, 0
  PRINT SPACE$(63);
  LOCATE 20, 16, 0
  PRINT "Date: " + DayName$(WorkDayOfWeekValue%) + ", " + LTRIM$(STR$(WorkDayValue%)) + " " + MonthName$(WorkMonthValue%) + " " + LTRIM$(STR$(WorkYearValue%)) + " year. Time: " + STRING$(2 - LEN(LTRIM$(STR$(WorkHourValue%))), "0") + LTRIM$(STR$(WorkHourValue%)) + ":" + STRING$(2 - LEN(LTRIM$(STR$(WorkMinuteValue%))), "0") + LTRIM$(STR$(WorkMinuteValue%)) + ":" + STRING$(2 - LEN(LTRIM$(STR$(WorkSecondValue%))), "0") + LTRIM$(STR$(WorkSecondValue%));
  COLOR 1, 7
  PRINT ".";
 END IF
 RETURN
CannotOpenSourceFile:
 IF MessageBox%("HexBinary.", "Cannot open source file. Retry opening?") THEN
  CALL ScratchScreen
  RESUME
 ELSE
  RESUME WorkRepeat
 END IF
CannotOpenTargetFile:
 IF MessageBox%("HexBinary.", "Cannot open target file. Retry opening?") THEN
  CALL ScratchScreen
  RESUME
 ELSE
  CLOSE #1
  RESUME WorkRepeat
 END IF
CannotReadFromSourceFileForGetCrc32:
 IF MessageBox%("HexBinary.", "Cannot read from source file. Retry reading?") THEN
  CALL ScratchScreen
  GOSUB OutGetCrc32StatusBox
  GOSUB OutGetCrc32Status
  RESUME
 ELSE
  CLOSE #1
  RESUME WorkRepeat
 END IF
CannotReadSourceFileForConvertToHex:
 IF MessageBox%("HexBinary.", "Cannot read from source file. Retry reading?") THEN
  CALL ScratchScreen
  GOSUB OutBinToHexStatusBox
  GOSUB OutBinToHexStatus
  RESUME
 ELSE
  CLOSE #1
  CLOSE #2
  KILL TargetFileName$
  RESUME WorkRepeat
 END IF
CannotWriteToTargetFileForConvertToHex:
 IF MessageBox%("HexBinary.", "Cannot write to target file. Retry writing?") THEN
  CALL ScratchScreen
  GOSUB OutBinToHexStatusBox
  GOSUB OutBinToHexStatus
  RESUME
 ELSE
  CLOSE #1
  CLOSE #2
  KILL TargetFileName$
  RESUME WorkRepeat
 END IF
CannotReadFromHexSourceFile:
 IF MessageBox%("HexBinary.", "Cannot read from source file. Retry reading?") THEN
  CALL ScratchScreen
  RESUME
 ELSE
  CLOSE #1
  RESUME WorkRepeat
 END IF
CannotReadFromSourceFileForConvertToBin:
 IF MessageBox%("HexBinary.", "Cannot read from source file. Retry reading?") THEN
  CALL ScratchScreen
  GOSUB OutHexToBinStatusBox
  GOSUB OutHexToBinStatus
  RESUME
 ELSE
  CLOSE #1
  CLOSE #2
  KILL TargetFileName$
  RESUME WorkRepeat
 END IF
CannotWriteToTargetFileForConvertToBin:
 IF MessageBox%("HexBinary.", "Cannot write to target file. Retry writing?") THEN
  CALL ScratchScreen
  GOSUB OutHexToBinStatusBox
  GOSUB OutHexToBinStatus
  RESUME
 ELSE
  CLOSE #1
  CLOSE #2
  KILL TargetFileName$
  RESUME WorkRepeat
 END IF

FUNCTION DateAndTimeToSeconds# (HourValue%, MinuteValue%, SecondValue%, DayValue%, MonthValue%, YearValue%)
 DateAndTimeToSeconds# = (YearValue% * (416 * 86400#)) + (MonthValue% * (32 * 86400)) + (DayValue% * 86400) + (HourValue% * 3600!) + (MinuteValue% * 60) + SecondValue%
END FUNCTION

FUNCTION DayName$ (DayNumber%)
 SELECT CASE DayNumber%
 CASE 1
   DayName$ = "Monday"
 CASE 2
   DayName$ = "Tuesday"
 CASE 3
   DayName$ = "Wednesday"
 CASE 4
   DayName$ = "Thursday"
 CASE 5
   DayName$ = "Friday"
 CASE 6
   DayName$ = "Saturday"
 CASE 7
   DayName$ = "Sunday"
 END SELECT
END FUNCTION

FUNCTION DayOfWeek% (DayValue%, MonthValue%, YearValue%)
 SELECT CASE DaysCount&(DayValue%, MonthValue%, YearValue%) - (INT(DaysCount&(DayValue%, MonthValue%, YearValue%) / 7) * 7)
 CASE 0
   DayOfWeek% = 6
 CASE 1
   DayOfWeek% = 7
 CASE 2
   DayOfWeek% = 1
 CASE 3
   DayOfWeek% = 2
 CASE 4
   DayOfWeek% = 3
 CASE 5
   DayOfWeek% = 4
 CASE 6
   DayOfWeek% = 5
 CASE 7
   DayOfWeek% = 6
 END SELECT
END FUNCTION

FUNCTION DayOfWeekName$ (DayValue%, MonthValue%, YearValue%)
 DayOfWeekName$ = DayName$(DayOfWeek%(DayValue%, MonthValue%, YearValue%))
END FUNCTION

FUNCTION DaysCount& (DayValue%, MonthValue%, YearValue%)
 DaysCount& = (YearValue% * 365#) + INT(YearValue% / 100) + INT(YearValue% / 4) + MonthDaysCount%(MonthValue%, YearValue%) + DayValue%
END FUNCTION

FUNCTION InputBox% (Title$, Message$, InputTextLine$)
 DIM OutMessage$
 DIM OutIndex%
 DIM WorkKey$
 DIM InputTextCursorColumn%
 DIM InputTextCursorPosition%
 DIM InputText$
 IF LEN(Message$) < 256 THEN OutMessage$ = Message$ + SPACE$(256 - LEN(Message$)) ELSE OutMessage$ = LEFT$(Message$, 256)
 CALL MakeBox(7, 8, 64, 7)
 PRINT LEFT$(Title$, 64) + SPACE$(64 - LEN(LEFT$(Title$, 64)));
 COLOR 1, 7
 FOR OutIndex% = 1 TO 4
  LOCATE 9 + OutIndex%, 8, 0
  PRINT LEFT$(OutMessage$, 64);
  OutMessage$ = MID$(OutMessage$, 65)
 NEXT OutIndex%
 COLOR 14, 7
 LOCATE 15, 8, 0
 PRINT "Please press key is equalient to your answer: ENTER=Yes, ESC=No.";
 InputTextCursorColumn% = 1
 InputTextCursorPosition% = 1
 InputText$ = InputTextLine$
 GOSUB OutInputLine
 DO
  WorkKey$ = INKEY$
  SELECT CASE LEN(WorkKey$)
  CASE 1
    SELECT CASE WorkKey$
    CASE CHR$(8)
      IF InputTextCursorColumn% > 1 THEN
       InputTextCursorColumn% = InputTextCursorColumn% - 1
       InputTextCursorPosition% = InputTextCursorPosition% - 1
       IF InputTextCursorColumn% < 1 THEN InputTextCursorColumn% = 1
       IF InputTextCursorPosition% < 1 THEN InputTextCursorPosition% = 1
       InputText$ = MID$(InputText$, 1, InputTextCursorColumn% - 1) + MID$(InputText$, InputTextCursorColumn% + 1)
       GOSUB OutInputLine
      END IF
    CASE CHR$(13)
      InputTextLine$ = InputText$
      EXIT DO
    CASE CHR$(27)
      EXIT DO
    CASE ELSE
      IF (LEN(InputText$) < 256) AND (ASC(WorkKey$) > (ASC(SPACE$(1)) - 1)) THEN
       InputText$ = MID$(InputText$, 1, InputTextCursorColumn% - 1) + WorkKey$ + MID$(InputText$, InputTextCursorColumn%)
       InputTextCursorColumn% = InputTextCursorColumn% + 1
       InputTextCursorPosition% = InputTextCursorPosition% + 1
       IF InputTextCursorColumn% > LEN(InputText$) + 1 THEN InputTextCursorColumn% = LEN(InputText$) + 1
       IF LEN(InputText$) > 63 THEN IF InputTextCursorPosition% > 64 THEN InputTextCursorPosition% = 64
       IF LEN(InputText$) < 65 THEN IF InputTextCursorPosition% > LEN(InputText$) + 1 THEN InputTextCursorPosition% = LEN(InputText$) + 1
       GOSUB OutInputLine
      END IF
    END SELECT
  CASE 2
    WorkKey$ = MID$(WorkKey$, 2)
    SELECT CASE WorkKey$
    CASE CHR$(75)
      IF InputTextCursorColumn% > 1 THEN
       InputTextCursorColumn% = InputTextCursorColumn% - 1
       InputTextCursorPosition% = InputTextCursorPosition% - 1
       IF InputTextCursorColumn% < 1 THEN InputTextCursorColumn% = 1
       IF InputTextCursorPosition% < 1 THEN InputTextCursorPosition% = 1
       GOSUB OutInputLine
      END IF
    CASE CHR$(77)
      IF InputTextCursorColumn% < LEN(InputText$) + 1 THEN
       InputTextCursorColumn% = InputTextCursorColumn% + 1
       InputTextCursorPosition% = InputTextCursorPosition% + 1
       IF InputTextCursorColumn% > LEN(InputText$) + 1 THEN InputTextCursorColumn% = LEN(InputText$) + 1
       IF LEN(InputText$) > 63 THEN IF InputTextCursorPosition% > 64 THEN InputTextCursorPosition% = 64
       IF LEN(InputText$) < 65 THEN IF InputTextCursorPosition% > LEN(InputText$) + 1 THEN InputTextCursorPosition% = LEN(InputText$) + 1
       GOSUB OutInputLine
      END IF
    CASE CHR$(71)
      IF InputTextCursorColumn% <> 1 THEN
       InputTextCursorColumn% = 1
       InputTextCursorPosition% = 1
       GOSUB OutInputLine
      END IF
    CASE CHR$(79)
      IF InputTextCursorColumn% <> LEN(InputText$) + 1 THEN
       InputTextCursorColumn% = LEN(InputText$) + 1
       InputTextCursorPosition% = LEN(InputText$) + 1
       IF LEN(InputText$) > 63 THEN IF InputTextCursorPosition% > 64 THEN InputTextCursorPosition% = 64
       IF LEN(InputText$) < 65 THEN IF InputTextCursorPosition% > LEN(InputText$) + 1 THEN InputTextCursorPosition% = LEN(InputText$) + 1
       GOSUB OutInputLine
      END IF
    CASE CHR$(83)
      IF InputText$ <> "" THEN
       InputText$ = MID$(InputText$, 1, InputTextCursorColumn% - 1) + MID$(InputText$, InputTextCursorColumn% + 1)
       GOSUB OutInputLine
      END IF
    END SELECT
  END SELECT
 LOOP
 LOCATE , , 0
 InputBox% = WorkKey$ = CHR$(13)
 EXIT FUNCTION
OutInputLine:
 COLOR 4, 7
 LOCATE 14, 8, 0
 PRINT MID$(InputText$, (InputTextCursorColumn% - InputTextCursorPosition%) + 1, 64) + SPACE$(64 - LEN(MID$(InputText$, (InputTextCursorColumn% - InputTextCursorPosition%) + 1, 64)));
 LOCATE 14, 7 + InputTextCursorPosition%, 1, 7, 8
 RETURN
END FUNCTION

FUNCTION IsLeapYear% (YearValue%)
 IsLeapYear% = ABS((INT(YearValue% / 4) * 4) = YearValue%)
END FUNCTION

SUB MakeBox (BoxColumn%, BoxRow%, BoxWidth%, BoxHeight%)
 DIM BoxWorkIndex%
 IF (BoxColumn% < 1) OR (BoxRow% < 1) OR (BoxWidth% < 1) OR (BoxHeight% < 1) OR (BoxWidth% > 77) OR (BoxHeight% > 22) OR (((BoxColumn% - 1) + BoxWidth%) > 77) OR (((BoxRow% - 1) + BoxHeight%) > 22) THEN EXIT SUB
 COLOR 0, 7
 LOCATE BoxRow%, BoxColumn%, 0
 PRINT CHR$(201) + STRING$(BoxWidth%, CHR$(205)) + CHR$(187);
 FOR BoxWorkIndex% = 1 TO BoxHeight% + 1
  LOCATE BoxRow% + BoxWorkIndex%, BoxColumn%, 0
  PRINT CHR$(186) + SPACE$(BoxWidth%) + CHR$(186);
  COLOR 0, 0
  PRINT SPACE$(1);
  COLOR 0, 7
 NEXT BoxWorkIndex%
 LOCATE BoxRow% + BoxHeight% + 1, BoxColumn%, 0
 PRINT CHR$(200) + STRING$(BoxWidth%, CHR$(205)) + CHR$(188);
 COLOR 0, 0
 LOCATE BoxRow% + BoxHeight% + 2, BoxColumn% + 1, 0
 PRINT SPACE$(BoxWidth% + 2);
 COLOR 15, 2
 LOCATE BoxRow% + 1, BoxColumn% + 1, 0
END SUB

FUNCTION MenuBox% (ItemsCount%)
 DIM MenuIndex%
 DIM MenuLineLength%
 DIM CurrentItem%
 DIM WorkKey$
 IF (ItemsCount% < 1) OR (ItemsCount% > UBOUND(MenuItems$)) OR (UBOUND(MenuItems$) > 20) THEN
  MenuBox% = 0
  EXIT FUNCTION
 END IF
 MenuLineLength% = 0
 FOR MenuIndex% = 1 TO ItemsCount%
  IF LEN(MenuItems$(MenuIndex%)) > MenuLineLength% THEN MenuLineLength% = LEN(MenuItems$(MenuIndex%))
 NEXT MenuIndex%
 IF MenuLineLength% < 56 THEN MenuLineLength% = 56
 IF MenuLineLength% > 75 THEN MenuLineLength% = 75
 CurrentItem% = 1
 GOSUB OutMenu
 DO
  WorkKey$ = UCASE$(INKEY$)
  SELECT CASE LEN(WorkKey$)
  CASE 1
    SELECT CASE WorkKey$
    CASE CHR$(13)
      MenuBox% = CurrentItem%
      EXIT DO
    CASE CHR$(27)
      MenuBox% = 0
      EXIT DO
    CASE ELSE
      IF (ASC(WorkKey$) > (ASC("A") - 1)) AND (ASC(WorkKey$) < (ASC("A") + ItemsCount%)) THEN
       CurrentItem% = (ASC(WorkKey$) - ASC("A")) + 1
       GOSUB OutMenu
      END IF
    END SELECT
  CASE 2
    WorkKey$ = MID$(WorkKey$, 2)
    SELECT CASE WorkKey$
    CASE CHR$(72)
      IF CurrentItem% > 1 THEN
       CurrentItem% = CurrentItem% - 1
       GOSUB OutMenu
      END IF
    CASE CHR$(80)
      IF CurrentItem% < ItemsCount% THEN
       CurrentItem% = CurrentItem% + 1
       GOSUB OutMenu
      END IF
    CASE CHR$(73)
      IF CurrentItem% <> 1 THEN
       CurrentItem% = 1
       GOSUB OutMenu
      END IF
    CASE CHR$(81)
      IF CurrentItem% <> ItemsCount% THEN
       CurrentItem% = ItemsCount%
       GOSUB OutMenu
      END IF
    CASE CHR$(71)
      IF CurrentItem% <> 1 THEN
       CurrentItem% = 1
       GOSUB OutMenu
      END IF
    CASE CHR$(79)
      IF CurrentItem% <> ItemsCount% THEN
       CurrentItem% = ItemsCount%
       GOSUB OutMenu
      END IF
    END SELECT
  END SELECT
 LOOP
 EXIT FUNCTION
OutMenu:
 CALL MakeBox(INT((80 - (MenuLineLength% + 5)) / 2) + 1, INT((25 - (ItemsCount% + 5)) / 2) + 1, MenuLineLength% + 2, ItemsCount% + 2)
 FOR MenuIndex% = 1 TO ItemsCount%
  COLOR 14, 7
  LOCATE INT((25 - (ItemsCount% + 5)) / 2) + (MenuIndex% + 1), INT((80 - (MenuLineLength% + 5)) / 2) + 2, 0
  PRINT CHR$(ASC("A") + (MenuIndex% - 1));
  COLOR 12, 7
  PRINT "=";
  IF MenuIndex% = CurrentItem% THEN COLOR 15, 6 ELSE COLOR 8, 7
  PRINT LEFT$(MenuItems$(MenuIndex%), MenuLineLength%) + SPACE$(MenuLineLength% - LEN(LEFT$(MenuItems$(MenuIndex%), MenuLineLength%)));
 NEXT MenuIndex%
 COLOR 0, 7
 LOCATE INT((25 - (ItemsCount% + 5)) / 2) + 2 + ItemsCount%, INT((80 - (MenuLineLength% + 5)) / 2) + 1, 0
 PRINT CHR$(204) + STRING$(MenuLineLength% + 2, CHR$(205)) + CHR$(185);
 COLOR 14, 7
 LOCATE INT((25 - (ItemsCount% + 5)) / 2) + 3 + ItemsCount%, INT((80 - (MenuLineLength% + 5)) / 2) + 2, 0
 PRINT SPACE$(INT((MenuLineLength% - 56) / 2) + 1) + "Please press ENTER to select menu item or ESC to cancel."
 RETURN
END FUNCTION

FUNCTION MessageBox% (Title$, Message$)
 DIM OutMessage$
 DIM OutIndex%
 DIM WorkKey$
 IF LEN(Message$) < 256 THEN OutMessage$ = Message$ + SPACE$(256 - LEN(Message$)) ELSE OutMessage$ = LEFT$(Message$, 256)
 CALL MakeBox(7, 9, 64, 6)
 PRINT LEFT$(Title$, 64) + SPACE$(64 - LEN(LEFT$(Title$, 64)));
 COLOR 1, 7
 FOR OutIndex% = 1 TO 4
  LOCATE 10 + OutIndex%, 8, 0
  PRINT LEFT$(OutMessage$, 64);
  OutMessage$ = MID$(OutMessage$, 65)
 NEXT OutIndex%
 COLOR 14, 7
 LOCATE 15, 8, 0
 PRINT "Please press key is equalient to your answer: ENTER=Yes, ESC=No.";
 WorkKey$ = ""
 WHILE (WorkKey$ <> CHR$(13)) AND (WorkKey$ <> CHR$(27))
  WorkKey$ = INKEY$
 WEND
 MessageBox% = WorkKey$ = CHR$(13)
END FUNCTION

FUNCTION MonthDays% (MonthValue%, YearValue%)
 SELECT CASE MonthValue%
 CASE 1
   MonthDays% = 31
 CASE 2
   MonthDays% = 28 + IsLeapYear%(YearValue%)
 CASE 3
   MonthDays% = 31
 CASE 4
   MonthDays% = 30
 CASE 5
   MonthDays% = 31
 CASE 6
   MonthDays% = 30
 CASE 7
   MonthDays% = 31
 CASE 8
   MonthDays% = 31
 CASE 9
   MonthDays% = 30
 CASE 10
   MonthDays% = 31
 CASE 11
   MonthDays% = 30
 CASE 12
   MonthDays% = 31
 END SELECT
END FUNCTION

FUNCTION MonthDaysCount% (MonthValue%, YearValue%)
 SELECT CASE MonthValue%
 CASE 1
   MonthDaysCount% = 0
 CASE 2
   MonthDaysCount% = 31
 CASE 3
   MonthDaysCount% = 59 + IsLeapYear%(YearValue%)
 CASE 4
   MonthDaysCount% = 90 + IsLeapYear%(YearValue%)
 CASE 5
   MonthDaysCount% = 120 + IsLeapYear%(YearValue%)
 CASE 6
   MonthDaysCount% = 151 + IsLeapYear%(YearValue%)
 CASE 7
   MonthDaysCount% = 181 + IsLeapYear%(YearValue%)
 CASE 8
   MonthDaysCount% = 212 + IsLeapYear%(YearValue%)
 CASE 9
   MonthDaysCount% = 243 + IsLeapYear%(YearValue%)
 CASE 10
   MonthDaysCount% = 273 + IsLeapYear%(YearValue%)
 CASE 11
   MonthDaysCount% = 304 + IsLeapYear%(YearValue%)
 CASE 12
   MonthDaysCount% = 334 + IsLeapYear%(YearValue%)
 END SELECT
END FUNCTION

FUNCTION MonthName$ (MonthNumber%)
 SELECT CASE MonthNumber%
 CASE 1
   MonthName$ = "January"
 CASE 2
   MonthName$ = "February"
 CASE 3
   MonthName$ = "March"
 CASE 4
   MonthName$ = "April"
 CASE 5
   MonthName$ = "May"
 CASE 6
   MonthName$ = "June"
 CASE 7
   MonthName$ = "July"
 CASE 8
   MonthName$ = "August"
 CASE 9
   MonthName$ = "September"
 CASE 10
   MonthName$ = "October"
 CASE 11
   MonthName$ = "November"
 CASE 12
   MonthName$ = "December"
 END SELECT
END FUNCTION

SUB OutBox (Title$, Message$)
 DIM OutMessage$
 DIM OutIndex%
 IF LEN(Message$) < 256 THEN OutMessage$ = Message$ + SPACE$(256 - LEN(Message$)) ELSE OutMessage$ = LEFT$(Message$, 256)
 CALL MakeBox(7, 9, 64, 6)
 PRINT LEFT$(Title$, 64) + SPACE$(64 - LEN(LEFT$(Title$, 64)));
 COLOR 1, 7
 FOR OutIndex% = 1 TO 4
  LOCATE 10 + OutIndex%, 8, 0
  PRINT LEFT$(OutMessage$, 64);
  OutMessage$ = MID$(OutMessage$, 65)
 NEXT OutIndex%
 COLOR 14, 7
 LOCATE 15, 8, 0
 PRINT "       Please press the ENTER key to quit from this box.";
 WHILE INKEY$ <> CHR$(13)
 WEND
END SUB

SUB ScratchScreen
 COLOR 0, 2
 CLS
 PRINT "********************************************************************************"
 PRINT "         The Standart GNU Personal Binary To Hexadecimal Text Convertor."
 PRINT "                     Copyright (C) Sandul Yura Valentinovich."
 PRINT "                        (R) Wednesday, 5 March 2003 year."
 PRINT
 PRINT "    This program is free software; you can redistribute it and/or modify it"
 PRINT "under the terms of the GNU General Public License as published by the Free"
 PRINT "Software Foundation; either version 2 of the License, or (at your option) any"
 PRINT "later version."
 PRINT "    This program is distributed in the hope that it will be useful, but WITHOUT"
 PRINT "ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS"
 PRINT "FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details."
 PRINT "    You should have received a copy of the GNU General Public License along with"
 PRINT "this program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,"
 PRINT "Cambridge, MA 02139, USA."
END SUB

SUB SecondsToDateAndTime (SecondsCount#, HourValue%, MinuteValue%, SecondValue%, DayValue%, MonthValue%, YearValue%, DayOfWeekValue%)
 DIM WorkValue#
 WorkValue# = SecondsCount#
 YearValue% = INT(WorkValue# / (416 * 86400))
 WorkValue# = WorkValue# - (YearValue% * (416 * 86400#))
 MonthValue% = INT(WorkValue# / (32 * 86400))
 WorkValue# = WorkValue# - (MonthValue% * (32 * 86400))
 DayValue% = INT(WorkValue# / 86400)
 WorkValue# = WorkValue# - (DayValue% * 86400)
 HourValue% = INT(WorkValue# / 3600)
 WorkValue# = WorkValue# - (HourValue% * 3600!)
 MinuteValue% = INT(WorkValue# / 60)
 SecondValue% = WorkValue# - (MinuteValue% * 60)
 DayOfWeekValue% = DayOfWeek%(DayValue%, MonthValue%, YearValue%)
END SUB

